<template>
  <box :loading="loading">
    <template v-slot:title>Users List</template>

    <div class="w-full flex flex-row justify-end">
      <lull-button type="info" @click="$router.push('/users/new')">
        New User
      </lull-button>
    </div>

    <lull-datatable
      class="w-full"
      v-if="data"
      :loading="loading"
      :data="data.items"
      :pageInfo="data.pageInfo"
      :totalCount="data.totalCount"
      :onNext="onNext"
      :onPrevious="onPrevious"
      @update:filterData="setFilterData"
    >
      <lull-datatableColumn
        id="email"
        label="Email"
        :sortable="true"
        :filterable="true"
      />

      <lull-datatableColumn
        id="firstName"
        label="First Name"
        :sortable="true"
        :filterable="true"
      />

      <lull-datatableColumn
        id="lastName"
        label="Last Name"
        :sortable="true"
        :filterable="true"
      />

      <lull-datatableColumn
        id="enabled"
        label="Enabled"
        :sortable="true"
        width="25rem"
        justifyContent="center"
      />

      <lull-datatableColumn id="roles" label="Roles" />

      <lull-datatableColumn
        :width="'25rem'"
        id="actions"
        justifyContent="center"
      >
        <span></span>
      </lull-datatableColumn>

      <template v-slot:roles="{ row }">
        {{ getRoles(row.roles) }}
      </template>

      <template v-slot:enabled="{ row }">
        <lull-icon
          v-if="!row.working"
          icon="fa-power-off"
          :class="['enabled cursor-pointer', { disabled: !row.enabled }]"
          @click="toggleUser(row)"
        />

        <lull-icon v-else icon="fa-spinner" class="animate-spin" />
      </template>

      <template v-slot:actions="{ row }">
        <lull-dropdown placement="bottom" :clickable="true">
          <lull-button class="w-0.5" type="info">
            <lull-icon icon="fa-ellipsis-h" />
          </lull-button>

          <template v-slot:menu>
            <lull-dropdown-item @click="$router.push(`/users/${row.id}`)">
              Edit User
            </lull-dropdown-item>
            <lull-dropdown-item @click="resetPassword(row.email)">
              Reset Password
            </lull-dropdown-item>
          </template>
        </lull-dropdown>
      </template>
    </lull-datatable>

    <confirm
      v-model="confirmationModal"
      :callback="confirmationCallback"
      :message="confirmationMessage"
    />
  </box>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  onBeforeMount,
  onBeforeUnmount,
  ref,
} from 'vue';
import { Confirm } from '@/core/components';
import { DatatableFilterData, useLullToast } from 'lull-ui';
import { UsersModule, UsersAction } from '@/store/Users';
import { useStore } from '@/store';
import { User, UserRole } from '@/core/models/user';

export default defineComponent({
  name: 'users',
  components: {
    confirm: Confirm,
  },
  setup() {
    const store = useStore();
    const filterData = ref<null | DatatableFilterData>(null);
    const loading = computed(() => store.getters['users/usersLoading']);
    const data = computed(() => store.getters['users/users']);
    const confirmationModal = ref<boolean>(false);
    const confirmationCallback = ref<Function | null>(null);
    const confirmationMessage = ref<string | null>(null);
    const toast = useLullToast();

    async function getUsers(): Promise<void> {
      await store.dispatch(`users/${UsersAction.GetUsers}`, {
        filter: filterData.value,
      });
    }

    async function onNext(cursor: string): Promise<void> {
      await store.dispatch(`users/${UsersAction.GetUsers}`, {
        after: cursor,
        filter: filterData.value,
      });
    }

    async function onPrevious(cursor: string): Promise<void> {
      await store.dispatch(`users/${UsersAction.GetUsers}`, {
        before: cursor,
        filter: filterData.value,
      });
    }

    async function setFilterData(filter: DatatableFilterData): Promise<void> {
      filterData.value = filter;
      await getUsers();
    }

    async function toggleUser(user: User): Promise<void> {
      const status = user.enabled ? 'deactivated' : 'activated';

      async function callback(): Promise<void> {
        await store.dispatch(`users/${UsersAction.ToggleUser}`, {
          id: user.id,
          enabled: user.enabled,
        });

        const status = !user.enabled ? 'disabled' : 'enabled';
        toast.success({
          title: 'Success',
          message: `${user.email} has been ${status}.`,
        });
      }

      confirmationMessage.value = `Are you sure you want to ${status} this user?`;
      confirmationCallback.value = callback;
      confirmationModal.value = true;
    }

    async function resetPassword(email: string): Promise<void> {
      await store.dispatch(`users/${UsersAction.PasswordReset}`, email);
      toast.success({
        title: 'Success',
        message: `Password reset email sent for user ${email}.`,
      });
    }

    function getRoles(roles: UserRole[]): string {
      const results = roles.map((x: UserRole) => x.role?.name);

      return results.join(', ');
    }

    onBeforeMount(async () => {
      await store.registerModule('users', UsersModule);
      await getUsers();
    });

    onBeforeUnmount(async () => {
      await store.unregisterModule('users');
    });

    return {
      filterData,
      loading,
      data,
      confirmationModal,
      confirmationCallback,
      confirmationMessage,
      onNext,
      onPrevious,
      setFilterData,
      toggleUser,
      resetPassword,
      getRoles,
    };
  },
});
</script>

<style lang="scss" scoped>
@import '../../assets/css/variables.scss';

.enabled {
  color: $button-primary;

  &.disabled {
    color: $button-secondary;
  }
}
</style>